#include <stdio.h>

#define	PI 3.14159265358979323846

extern	double	sin();
extern	double	cos();

void	Gen_Gitter()
{
	FILE	*f;
	char	fileName[120];
	int	n;

	printf( "Generiere Gitter\n\n" );
	printf( " Groesse des Gitters: " );
	scanf( "%d", &n );
	printf( "Instanzdatei: " );
	scanf( "%s", fileName );

	f = fopen( fileName, "w" );
	fprintf( f, "%d\n", n*n );		/* Anzahl der Knoten */
	if ( (n%2) == 0 ) {
		int	i, j;
	
		fprintf( f, "%.1f\n", (float)(n*n) );	/* Lange des kuerzesten Weges */
		fprintf( f, "1\n" );			/* Instanz-Modus */
		for ( i=0; i < n; i++ )
			if ( (i%2) == 0 )
				for ( j=1; j<n; j++ )
					fprintf( f, "%d %d\n", i, j );
			else
				for ( j=n-1; j>0; j-- )
					fprintf( f, "%d %d\n", i, j );
		j = 0;
		for ( i=n-1; i>=0; i-- )
			fprintf( f, "%d %d\n", i, j );
	} else {
	}
	fclose( f );
}

void	Gen_Kreis()
{
	FILE	*f;
	char	fileName[120];
	int	n;
	double	a, b, phi;
	int	i;

	printf( "Generiere Kreis\n\n" );
	printf( "Groesse des Kreis: " );
	scanf( "%d", &n );
	printf( "a: " );
	scanf( "%lf", &a );
	printf( "b: " );
	scanf( "%lf", &b );
	printf( "phi: " );
	scanf( "%lf", &phi );
	printf( "Instanzdatei: " );
	scanf( "%s", fileName );

	f = fopen( fileName, "w" );
	fprintf( f, "%d\n", n );		/* Anzahl der Knoten */
	fprintf( f, "1\n" );			/* Lange des kuerzesten Weges */
	fprintf( f, "1\n" );			/* Instanz-Modus */
	for ( i=0; i < n; i++ ) {
		double	winkel;

		winkel = i * (2*PI/n);
		fprintf( f, "%lf %lf\n", a + a*sin( winkel + phi ), b+ b*cos( winkel ) );
	}
	fclose( f );
}

void	Gen_Eier()
{
	FILE	*f;
	char	fileName[120];
	int	n;
	double	a, b, phi;
	int	i;

	printf( "Generiere Eier\n\n" );
	printf( "Groesse eines Eies: " );
	scanf( "%d", &n );
	a = 20;
	b = 15;
	phi = PI / 4.0;
	printf( "Instanzdatei: " );
	scanf( "%s", fileName );

	f = fopen( fileName, "w" );
	fprintf( f, "%d\n", 2*n );			/* Anzahl der Knoten */
	if ( n == 100 )
		fprintf( f, "211.532318\n" );			/* Lange des kuerzesten Weges */
	if ( n == 200 )
		fprintf( f, "213.374969\n" );			/* Lange des kuerzesten Weges */
	fprintf( f, "1\n" );				/* Instanz-Modus */
	for ( i=0; i < n; i++ ) {
		double	winkel;

		winkel = i * (2*PI/n ) - PI / 4.0;
		fprintf( f, "%lf %lf\n", a + a*sin( winkel + phi ), b+ b*cos( winkel ) );
	}
	for ( i=0; i < n; i++ ) {
		double	winkel;

		winkel = i * (2*PI/n ) + PI / 4.0;
		fprintf( f, "%lf %lf\n", a + a*sin( winkel - phi ), b+ b*cos( winkel ) );
	}
	fclose( f );
}

main( argc, argv )
int	argc;
char	**argv;
{
	int	select;

	printf(" Generiere Instanzen\n\n" );
	printf( " < 1 > Gitter\n" );
	printf( " < 2 > Kreis\n" );
	printf( " < 3 > Eier\n" );
	scanf( "%d", &select );
	switch ( select ) {
		case 1:
			Gen_Gitter();
			break;
		case 2:
			Gen_Kreis();
			break;
		case 3:
			Gen_Eier();
			break;
	}
}
